#!/bin/bash

# kmodtool - Helper script for building kernel module RPMs
# Copyright (c) 2003-2006 Ville Skyttä <ville.skytta@iki.fi>,
#                         Thorsten Leemhuis <fedora@leemhuis.info>
#                         Jon Masters <jcm@redhat.com>
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

shopt -s extglob

myprog="virtio-kmodtool-el3"
myver="0.10.10_kmp2-el3"
knownvariants=@(BOOT|PAE|@(big|huge)mem|debug|enterprise|?(large)smp)
kmod_name=
kver=
verrel=
variant=
kmp=

get_verrel ()
{
  verrel=${1:-$(uname -r)}
#  verrel=$(ls -t /boot/config-* | head -1 | sed -e 's|/boot/config-||')
  verrel=${verrel%%$knownvariants}
}

print_verrel ()
{
  get_verrel $@
  echo "${verrel}"
}

get_variant ()
{
  get_verrel $@
  variant=${1:-$(uname -r)}
  variant=${variant##$verrel}
  variant=${variant:-'""'}
}

print_variant ()
{
  get_variant $@
  echo "${variant}"
}

get_rpmtemplate ()
{
    local variant="${1}"
    local dashvariant="${variant:+-${variant}}"
    case "$verrel" in
        *.el*) kdep="kernel${dashvariant}-%{_target_cpu} = ${verrel}" ;;
        *.EL*) kdep="kernel${dashvariant}-%{_target_cpu} = ${verrel}" ;;
        *)     kdep="kernel-%{_target_cpu} = ${verrel}${variant}"     ;;
    esac

    echo "%package       -n kmod-${kmod_name}${dashvariant}"

    if [ -z "$kmp_provides_summary" ]; then
        echo "Summary:          ${kmod_name} kernel module(s)"
    fi

    if [ -z "$kmp_provides_group" ]; then
        echo "Group:            System Environment/Kernel"
    fi

    if [ ! -z "$kmp" ]; then
        echo "Version: %{kmp_version}"
        echo "Release: %{kmp_release}"
    fi
    
    if [ ! -z "$kmp" ]; then
        echo "%global _use_internal_dependency_generator 0"
    fi
    
    cat <<EOF
Provides:         kernel-modules = ${verrel}${variant}
Provides:         ${kmod_name}-kmod = %{?epoch:%{epoch}:}%{version}-%{release}
EOF
    
    if [ -z "$kmp" ]; then
        echo "Requires:         ${kdep}"
    fi
    
    cat <<EOF
Requires(post):   /sbin/depmod
Requires(post):   /sbin/chkconfig
Requires(postun): /sbin/depmod
Requires(postun): /sbin/chkconfig
EOF

if [ "no" != "$kmp_nobuildreqs" ]
then
# rhel-3 doesn't have -devel pkgs; single source pkg for kmods
#    echo "BuildRequires: kernel-source-%{_target_cpu} = ${verrel}"
    echo "BuildRequires: kernel-source = ${verrel}"
fi

# Can't do following check due to lack of Provides in kernel spec file
# echo "Requires: kernel${dashvariant}-%{_target_cpu}"

if [ "" != "$kmp_override_preamble" ]
then
    cat "$kmp_override_preamble"
fi

cat <<EOF
%description   -n kmod-${kmod_name}${dashvariant}
This package provides the ${kmod_name} kernel modules built for the Linux
kernel ${verrel}${variant} for the %{_target_cpu} family of processors.
%post          -n kmod-${kmod_name}${dashvariant}
depmod
if [ "\${1}" = 1 ]; then
  modprobe virtio 2>/dev/null
  modprobe virtio_ring 2>/dev/null
  modprobe virtio_blk 2>/dev/null

  module="virtblk"
  mode="664"
  major=\`awk "\\\\\$2==\"\$module\\" {print \\\\\$1}" /proc/devices\`

  if [ -n "\$major" ]; then
    dn=0
    for dl in a b c d e f g h i j k l m n o; do
      if [ ! -e "/dev/vd\$dl" ]; then
        mknod /dev/vd\$dl b \$major \$dn
        for pn in 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15; do
          dn2=\$[\$dn+\$pn]
          mknod /dev/vd\${dl}\${pn} b \$major \$dn2
        done
      fi
      dn=\$[\$dn+16]
    done
  fi
fi

cp -f /boot/initrd-${verrel}${variant}.img /boot/initrd-${verrel}${variant}.img.virtio.orig 2>/dev/null

mkinitrd --with virtio --with virtio_ring --with virtio_blk --with virtio_net --with virtio_pci -f /boot/initrd-${verrel}${variant}.img ${verrel}${variant}
EOF

    cat <<EOF
%postun        -n kmod-${kmod_name}${dashvariant}
if [ "\${1}" = 0 ]; then
  rm -f /dev/vd*
fi
mv -f /boot/initrd-${verrel}${variant}.img.virtio.orig /boot/initrd-${verrel}${variant}.img 2>/dev/null

EOF
 
echo "%files         -n kmod-${kmod_name}${dashvariant}"

if [ "" == "$kmp_override_filelist" ];
then
    echo "%defattr(644,root,root,755)"
# avoid including conflicting build, kernel, pcmcia directories
    echo "/lib/modules/${verrel}${variant}/kernel/drivers"
    echo "%doc /usr/share/doc/${kmod_name}-%{version}-%{release}/README.el3"

else
    cat "$kmp_override_filelist"
fi
}

print_rpmtemplate ()
{
  kmod_name="${1}"
  shift
  kver="${1}"
  get_verrel "${1}"
  shift
  if [ -z "${kmod_name}" ] ; then
    echo "Please provide the kmodule-name as first parameter." >&2
    exit 2
  elif [ -z "${kver}" ] ; then
    echo "Please provide the kver as second parameter." >&2
    exit 2
  elif [ -z "${verrel}" ] ; then
    echo "Couldn't find out the verrel." >&2
    exit 2
  fi
  
  for variant in "$@" ; do
      if [ "default" == "$variant" ];
      then
            get_rpmtemplate ""
      else
            get_rpmtemplate "${variant}"
      fi
  done
}

usage ()
{
  cat <<EOF
You called: ${invocation}

Usage: ${myprog} <command> <option>+
 Commands:
  verrel <uname>                               
    - Get "base" version-release.
  variant <uname>                               
    - Get variant from uname.
  rpmtemplate <mainpgkname> <uname> <variants> 
    - Return a template for use in a source RPM
  rpmtemplate_kmp <mainpgkname> <uname> <variants>
    - Return a template for use in a source RPM with KMP dependencies
  version  
    - Output version number and exit.
EOF
}

invocation="$(basename ${0}) $@"
while [ "${1}" ] ; do
  case "${1}" in
    verrel)
      shift
      print_verrel $@
      exit $?
      ;;
    variant)
      shift
      print_variant $@
      exit $?
      ;;
    rpmtemplate)
      shift
      print_rpmtemplate "$@"
      exit $?
      ;;
    rpmtemplate_kmp)
      shift
      kmp=1
      print_rpmtemplate "$@"
      exit $?
      ;;
    version)
      echo "${myprog} ${myver}"
      exit 0
      ;;
    *)
      echo "Error: Unknown option '${1}'." >&2
      usage >&2
      exit 2
      ;;
  esac
done

# Local variables:
# mode: sh
# sh-indentation: 2
# indent-tabs-mode: nil
# End:
# ex: ts=2 sw=2 et
